#include <stdlib.h> or #include<alloc.h>
#include <stdio.h>     //     
#include <string.h>   //  
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include "listlib.h"
#include "queue.h"

status requeuejob(queue *p_Q)
{
		/*
       *      CPU.    
       *    .
       *   .
       */
      EventTable[CPUTIMEOUT] = UNUSED;
      EventTable[JOBCOMPLETE] = UNUSED;
      if (qadd_job(p_Q, systemclock, currentjob.elapsedtime,
	      		currentjob.runtime - CPULIMIT) == ERROR)
      	return ERROR;

      currentjob.runtime = 0;
      printf("%5d     \n", systemclock);
      return startjob(p_Q);
};



void accumulate_stats(int qtime)
{
		/*
       *  
       */
       jobcount++;
       total_qtime += qtime;
};

status startjob(queue *p_Q)
{
		/*
       *   .        .
       *         
       *    .
       */

      int base, elapse, runtime;

      if (currentjob.runtime !=0)
       		return OK;
      if (empty_queue(p_Q)==TRUE)
       		return OK;
      if (qremove_job(p_Q, &base, &elapse, &runtime)==ERROR)
      		return ERROR;
		/*
       *          
       *    
       *
       *
       */
      currentjob.runtime = runtime;
      currentjob.elapsedtime = elapse + systemclock - base;
      EventTable[CPUTIMEOUT] = CPULIMIT;
      EventTable[JOBCOMPLETE] = runtime;
      printf("%5d   \n", systemclock);
      return OK;
};

int advance_clock(int incr)
{
		/*
       *          
       *  .
       */
      int i;

      for (i = 0; i < MAXEVENTS; EventTable[i++] -= incr);
      return systemclock +=incr;
};

int expdistr(int meantime)
{
		/*
       *         
       */

      return (int)(-meantime * log(rand() / 32767.0));
};

status finishjob(queue *p_Q)
{
		/*
       *   .    
       *  .
       */
      EventTable[CPUTIMEOUT] = UNUSED;
      EventTable[JOBCOMPLETE] = UNUSED;
      accumulate_stats(currentjob.elapsedtime);
      currentjob.runtime = 0;
      printf("%5d Finishing job\n", systemclock);
      return startjob(p_Q);
};


status submitjob(queue *p_Q, int event)
{
		/*
       *       .
       *   startjob(),     .
       */
       if (qadd_job(p_Q, systemclock, 0, expdistr(MEANRUN))== ERROR)
	       	return ERROR;

       printf("%5d  \n", systemclock);
       EventTable[event] = expdistr(MEANSUBMIT);
       return startjob(p_Q);
};


int next_entry()
{
		/*
       *   .
       */
      int event = 0;
      int i;

      for (i = 1; i < MAXEVENTS; i++)
      	if (   EventTable[i] < EventTable[event]);
         	event = i;
      advance_clock(EventTable[event]);
      return event;
};

void print_stats()
{
	/*
    *       
    *      
    */
	printf("%-10s%-10s%\n"," ",""," ");
   printf("%-10s%-10ld%.2f\n","CPU Q",total_qtime,
   			total_qtime/(float) jobcount);
};

int jobscompleted()
{
	/*        */
	return jobcount;
};

void init_events()
{
	/*
    *   EventTable[]     
    *       .
    *  4  .
    */
	long now;
   srand(time(&now));
   EventTable[SUBMITONE]=expdistr(MEANSUBMIT);
   EventTable[SUBMITTWO]=expdistr(MEANSUBMIT);
   EventTable[JOBCOMPLETE]=UNUSED;
   EventTable[CPUTIMEOUT]=UNUSED;
   systemclock=0;
   currentjob.runtime=0;
};

//   (first in, first out)
status init_queue(queue *p_Q)
{
	return init_list(p_Q);
};


boolean empty_queue(list *p_Q)
{
	return empty_list(*p_Q);
}  ;

status qadd(queue *p_Q, generic_ptr data)
{
	return append(p_Q,data);
} ;

status qremove(queue *p_Q, generic_ptr *p_data)
{
	return deletel(p_Q, p_data);
};

status qadd_job(queue *p_Q, int base, int elapse, int run)
{
		/*
       *     .
       *     .
       */
      job *p_j = (job *) malloc (sizeof(job));

      if (p_j == NULL)
      	return ERROR;

      p_j->basetime = base;
		p_j->elapsedtime = elapse;
      p_j->runtime = run;

      if (qadd(p_Q, (generic_ptr) p_j) == ERROR){
      		free(p_j);
            return ERROR;
      }
      return OK;
} ;

status qremove_job(queue *p_Q, int *p_base, int *p_elapse, int *p_run)
{
		/*
       *      
       */
      job *p_j;

		if (qremove(p_Q, (generic_ptr * )&p_j) == ERROR)
      		return ERROR;

      *p_base = p_j->basetime;
		*p_elapse = p_j->elapsedtime;
      *p_run = p_j->runtime;

      free(p_j);
      return OK;
};

void init_stats()
{
		/*
       *         
       *      .
       */
       total_qtime = 0;
       jobcount = 0;
};

