//       queue.cpp
//       
#ifndef _queue_h_
#define _queue_h_

#define MEANSUBMIT 8
#define MEANRUN 15
#define CPULIMIT 20
#define MAXEVENTS 4
#define MAXQUEUESIZE 10000
#define UNUSED 1000
#define FRONT(Q) ((Q)->front)
#define REAR(Q) ((Q)->rear)
#define SUBMITONE 0
#define SUBMITTWO 1
#define JOBCOMPLETE 2
#define CPUTIMEOUT 3


#define TRUE 1
#define FALSE 0

#define ERROR 0
#define OK 1

typedef void*  generic_ptr ;
typedef int  status ;
typedef int  boolean ;


typedef struct {
	int basetime;
   int elapsedtime;
   int runtime;
} job;

//    
struct queue {
	generic_ptr base[MAXQUEUESIZE];
   generic_ptr * top;
};


// 
status requeuejob(queue *p_Q);
void accumulate_stats(int q_time);
status startjob(queue *p_Q);
int advance_clock(int incr);
static int systemclock;
static int EventTable[MAXEVENTS];
static job currentjob;
static int jobcount;
static long total_qtime;

int expdistr(int meantime);
status finishjob(queue *p_Q);
status submitjob(queue *p_Q,int event);
int next_entry();
void print_stats();
int jobscompleted();
void init_events();
void init_stats();
status init_queue(queue *p_Q);
boolean empty_queue(queue *p_Q);
status qadd(queue *p_Q, generic_ptr data);
status qremove(queue *p_Q, generic_ptr *p_data);
status qadd_job(queue *p_Q, int base, int elapse, int run);
status qremove_job(queue *p_Q, int *p_base, int *p_elapse, int *p_run);

#endif
